// Romi Chassis – obsługa enkoderów
// Program 1
// Autor: Patryk Mądry 
// Mikrokontroler 2017 r.

#define PinA 2  
#define PinB 3  

long licznik = 0;
int kierunek = 1;

void Jedz_do_przodu(int i)
{
  kierunek = 1;
  
  // Lewy silnik
  digitalWrite(6,LOW);
  analogWrite(10,i);
  // Prawy silnik 
  digitalWrite(7,LOW);
  analogWrite(11,i);
  
}

void Jedz_do_tylu(int i)
{
  kierunek = 0;
  
  // Lewy silnik
  digitalWrite(6,HIGH);
  analogWrite(10,i);
  
  // Prawy silnik 
  digitalWrite(7,HIGH);
  analogWrite(11,i);
}

void Stop()
{
   // Lewy silnik
  digitalWrite(6,LOW);
  analogWrite(10,0);
  
  // Prawy silnik 
  digitalWrite(7,LOW);
  analogWrite(11,0);

}


void setup() {

  Serial.begin(9600);
  pinMode(PinA,INPUT); 
  pinMode(PinB,INPUT); 

  attachInterrupt(0, Kanal_A, CHANGE);  
  attachInterrupt(1, Kanal_B, CHANGE);
   
  pinMode(10,OUTPUT);
  pinMode(11,OUTPUT);

  pinMode(6,OUTPUT);
  pinMode(7,OUTPUT);

}

void loop() {
  
  delay(3000);
 
  while(1)
  {

  //Jedz do przodu przez 1440 impulsów ( jeden obrot koła, około 22 cm) 
  while(licznik <=1440)
  {

    Jedz_do_przodu(30);
    Serial.print("Licznik: "); 
    Serial.println(licznik);
  }

  // Zatrzymanie 
  Stop();
  delay(3000);

  //Jedz do tylu przez 1440 impulsów (jeden obrot koła, około 22 cm) 
   while(licznik>0)
  {

    Serial.print("Licznik: "); 
    Serial.println(licznik);
    Jedz_do_tylu(30);
    
  }
  // Zatrzymanie 
  Stop();
  delay(3000);
  

}
}

void Kanal_A()
{
  if (kierunek==1)
  {
    licznik++; 
  }
  else if (kierunek==0)
  {
    licznik--; 
  }
  
}

void Kanal_B()
{
  
   if (kierunek==1)
  {
    licznik++; 
  }
  else if (kierunek==0)
  {
    licznik--; 
  }
}

